//+------------------------------------------------------------------+
//|                                                       KST-CT.mq4 |
//|                               Copyright  2009, Patrick Ferreira |
//|                               Modification Madaster@free.fr      |
//| 2009-07-06 add MMe21                                             |
//| futur ehancement  add band bollinger                             |
//+------------------------------------------------------------------+

#property  copyright "Copyright  2006, Robert Hill"
//---- indicator settings
#property  indicator_separate_window
#property indicator_buffers 3
// before 2
#property  indicator_color1  Green
#property  indicator_color2  Red
// new for MMe21
#property  indicator_color3  Blue

//---- indicator parameters
//// Court terme
//   w=3   x=4   y=6     z=10
//   wa=3 wb=4 wc=6 wd=8
// mme1=8 mme2=21
//moyen terme
// w=10   x=13   y=15     z=20
//  wa=10 wb=13 wc=15 wd=20
// mme1=8 mme2=21
//-------------------------------------------
//long terme
// w=39   x=52   y=78     z=104
//  wa=26 wb=26 wc=26 wd=39
// mme1=8 mme2=21

// salve parameter W X Y Z
extern int RPeriod1 = 3;
extern int RPeriod2 = 4;
extern int RPeriod3 = 6;
extern int RPeriod4 = 10;
// Salve parameter WA WB WC WD
extern int MPeriod1 = 3;
extern int MPeriod2 = 4;
extern int MPeriod3 = 6;
extern int MPeriod4 = 8;
// MMe8 & MMe21
extern int per_MA_KST = 8;
extern int per_MA_KST_21 = 21;
//---- indicator buffers

double ROCEMA1[];
double ROCEMA2[];
double ROCEMA3[];
double ROCEMA4[];

double KST[];
double MA_KST[];// MMe8
double MA_KST_21[];//MMe21

double RateOfChange[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexStyle(1,DRAW_SECTION);
   //new
   SetIndexStyle(2,DRAW_SECTION);

//---- indicator buffers mapping
   SetIndexBuffer(0,KST);
   SetIndexBuffer(1,MA_KST);
  SetIndexBuffer(2,MA_KST_21);
 //  SetIndexBuffer(2,ROCEMA1);
   SetIndexBuffer(3,ROCEMA2);
   SetIndexBuffer(4,ROCEMA3);
   SetIndexBuffer(5,ROCEMA4);
   SetIndexBuffer(6,RateOfChange);
   SetIndexBuffer(7,ROCEMA1);// qu'importe l'ordre


  SetIndexEmptyValue(2,0.0);//MA_kst_21
  SetIndexEmptyValue(3,0.0);//ROC 1
  SetIndexEmptyValue(4,0.0);
  SetIndexEmptyValue(5,0.0);
  SetIndexEmptyValue(6,0.0);//ROC 4
  SetIndexEmptyValue(7,0.0);// rate of Change

//---- indicator short name
   IndicatorShortName("KST-CT");
//---- initialization done

   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit,limit1,limit2,limit3,limit4;
   double ROC, CurrentClose, PrevClose;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0)
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0)
       counted_bars--;
   limit  = Bars - counted_bars - 1;
   limit1 = Bars - counted_bars - RPeriod1;//w
   limit2 = Bars - counted_bars - RPeriod2;//x
   limit3 = Bars - counted_bars - RPeriod3;//y
   limit4 = Bars - counted_bars - RPeriod4;//z

//---- ROC calculation  W
   for(int i = 0; i < limit1; i++)
     {
       CurrentClose = iClose(NULL, 0, i);
       PrevClose = iClose(NULL, 0, i + RPeriod1);
       ROC = CurrentClose - PrevClose;
       RateOfChange[i] = 100 * ROC / PrevClose;// on rempli donc une table
     }
   for( i = 0; i < limit1; i++)
       ROCEMA1[i]=iMAOnArray(RateOfChange,Bars,MPeriod1,0,MODE_EMA,i);
//+--------------- X ---------------------------------------------------+
   for( i = 0; i < limit2; i++)
     {
       CurrentClose = iClose(NULL, 0, i);
       PrevClose = iClose(NULL, 0, i + RPeriod2);//x
       ROC = CurrentClose - PrevClose;
       RateOfChange[i] = 100 * ROC / PrevClose;
     }
   for( i = 0; i < limit2; i++)
       ROCEMA2[i]=iMAOnArray(RateOfChange,Bars,MPeriod2,0,MODE_EMA,i);
//+-------------- Y ----------------------------------------------------+
   for( i = 0; i < limit3; i++)
     {
       CurrentClose = iClose(NULL, 0, i);
       PrevClose = iClose(NULL, 0, i + RPeriod3);
       ROC = CurrentClose - PrevClose;
       RateOfChange[i] = 100 * ROC / PrevClose;
     }
   for( i = 0; i < limit3; i++)
       ROCEMA3[i]=iMAOnArray(RateOfChange,Bars,MPeriod3,0,MODE_EMA,i);
//+--------------- Z ---------------------------------------------------+
   for( i = 0; i < limit4; i++)
     {
       CurrentClose = iClose(NULL, 0, i);
       PrevClose = iClose(NULL, 0, i + RPeriod4);
       ROC = CurrentClose - PrevClose;
       RateOfChange[i] = 100 * ROC / PrevClose;
     }
   for( i = 0; i < limit4; i++)
       ROCEMA4[i]=iMAOnArray(RateOfChange,Bars,MPeriod4,0,MODE_EMA,i);
//+---------------fin de W X Y Z ---------------------------------------------------+
   for( i = 0; i < limit; i++)
 // OLD      KST[i] = ((ROCEMA1[i])+(ROCEMA2[i]*2)+(ROCEMA3[i]*3)+(ROCEMA4[i]*4));
 // MODE FIBO SALVE
              KST[i] = ((ROCEMA1[i]*1.618)+(ROCEMA2[i]*1.50)+(ROCEMA3[i]*1.382)+(ROCEMA4[i]*1.236));
       //kst=(ma*1.618)+(mb*1.50)+(mc*1.382)+(md*1.236)
   for( i = 0; i < limit; i++)
       MA_KST[i]=iMAOnArray(KST,Bars,per_MA_KST,0,MODE_EMA,i);
       //   per_MA_KST=14
   // NEW MME21
   for( i = 0; i < limit; i++)
       MA_KST_21[i]=iMAOnArray(KST,Bars,per_MA_KST_21,0,MODE_EMA,i);
       //   per_MA_KST_21=21

//---- done
   return(0);
  }
//+------------------------------------------------------------------+